@make(ais)
@aiInfo(topic=<Correction to question in AI-00409/03>,
number=[AI-00483/04],
classcode=[CR],
statuscode=[WJ],
mainref=[12.03@\(05)],
date=[87-09-12])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class correction 86-10-13
!status approved by WG9/AJPO 87-07-30
@end(toplines)
!status approved by Director, AJPO 87-07-30
!status approved by Ada Board 87-07-30
!status approved by WG9 87-05-29
!status panel/committee-approved 87-01-19 (reviewed)
!status panel/committee-approved (6-0-0) 86-11-14 (pending editorial review)
!status work-item 86-10-15
!status received 86-10-13
@references[!references AI-00409, @CommentNum[83-00821]83-00821]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 86-10-13]

The instantiation of SET_@|OF in the question is illegal because the formal
generic type is an integer type.  The formal type should be declared as a
discrete type.

@subheading[!question 86-10-13]

The question in AI-00409/03 contains this example:
@begin(example)
@key[generic]
    @key[type] T @key[is] @key[range] <>;
@key[package] SET_@|OF @key[is]
    @key[type] SET @key[is] @key[array] (T) @key[of] BOOLEAN;
@key[end] SET_@|OF;
@hinge()

@key[package] CHARACTER_@|SET @key[is] @key[new] SET_@|OF (CHARACTER);
@key[subtype] CHAR_@|SET @key[is] CHARACTER_@|SET.SET;
@end(example)
The instantiation of SET_@|OF is illegal because the formal generic parameter
requires an INTEGER type.

@subheading[!recommendation 87-06-04]

The generic parameter declaration in the example given in the question should
be changed to read:
@begin(example)
@key[type] T @key[is] (<>);
@end(example)
@subheading[!discussion 86-10-13]

To allow an instantiation with type CHARACTER, the formal parameter must have
a discrete type, not an integer type.

